DECLARE @unprocessed_eeds TABLE (Id UNIQUEIDENTIFIER, CreatedOn DATETIME)

INSERT INTO @unprocessed_eeds (Id, CreatedOn)
SELECT eed.Id, eed.CreatedOn
FROM EnrchEmailData eed WITH (NOLOCK)
WHERE EXISTS (
	SELECT NULL
	FROM EnrchTextEntity ete WITH (NOLOCK)
	WHERE ete.EnrchEmailDataId = eed.Id
	AND NOT EXISTS (
		SELECT NULL
		FROM EnrchProcessedData epd  WITH (NOLOCK)
		WHERE epd.TextEntityHash = ete.[Hash]
	)
)
ORDER BY eed.CreatedOn DESC

DECLARE @eedId UNIQUEIDENTIFIER = (SELECT TOP 1 Id FROM @unprocessed_eeds ORDER BY CreatedOn DESC)

WHILE @eedId IS NOT NULL BEGIN
	UPDATE Activity
	SET EnrchEmailDataId = NULL,
		EnrichStatus = ''
	WHERE EnrchEmailDataId = @eedId

	DELETE FROM EnrchEmailData WHERE Id = @eedId
	DELETE FROM @unprocessed_eeds WHERE Id = @eedId

	SET @eedId = (SELECT TOP 1 Id FROM @unprocessed_eeds ORDER BY CreatedOn DESC)
END