﻿DECLARE @DisableTriggerTemplate NVARCHAR(MAX) = 'DISABLE TRIGGER @TriggerName ON @TableName';
DECLARE @Cmd NVARCHAR(MAX);
DECLARE @TriggerName SYSNAME;
DECLARE @TableName SYSNAME;
DECLARE @ReferencedTableName SYSNAME = 'SysImage';

IF OBJECT_ID('DisabledTriggers') IS NOT NULL
	DROP TABLE DisabledTriggers;
CREATE TABLE DisabledTriggers (
	TriggerName SYSNAME,
	TableName SYSNAME
);

INSERT INTO DisabledTriggers (TriggerName, TableName)
	SELECT
		OBJECT_NAME(d.referencing_id) AS TriggerName
	   ,OBJECT_NAME(t.parent_id) AS TableName
	FROM sys.sql_expression_dependencies d
	JOIN sys.triggers t
		ON t.object_id = d.referencing_id
	WHERE referenced_entity_name = @ReferencedTableName
		AND t.is_disabled = 0;

DECLARE cur CURSOR FAST_FORWARD READ_ONLY LOCAL FOR
	SELECT
		TriggerName,
		TableName
	FROM DisabledTriggers
	ORDER BY TableName;

OPEN cur;

FETCH NEXT FROM cur INTO @TriggerName, @TableName;
WHILE @@FETCH_STATUS = 0 BEGIN
	SET @Cmd = REPLACE(@DisableTriggerTemplate, '@TriggerName', QUOTENAME(@TriggerName));
	SET @Cmd = REPLACE(@Cmd, '@TableName', QUOTENAME(@TableName));
	PRINT @Cmd;
	EXEC (@Cmd);
	FETCH NEXT FROM cur INTO @TriggerName, @TableName;
END

CLOSE cur;
DEALLOCATE cur;