﻿DECLARE @EnableTriggerTemplate NVARCHAR(MAX) = 'ENABLE TRIGGER @TriggerName ON @TableName';
DECLARE @Cmd NVARCHAR(MAX);
DECLARE @TriggerName SYSNAME;
DECLARE @TableName SYSNAME;

IF OBJECT_ID('DisabledTriggers') IS NULL
	RETURN;

DECLARE cur CURSOR FAST_FORWARD READ_ONLY LOCAL FOR
	SELECT
		TriggerName,
		TableName
	FROM DisabledTriggers
	ORDER BY TableName;

OPEN cur;

FETCH NEXT FROM cur INTO @TriggerName, @TableName;
WHILE @@FETCH_STATUS = 0 BEGIN
	SET @Cmd = REPLACE(@EnableTriggerTemplate, '@TriggerName', QUOTENAME(@TriggerName));
	SET @Cmd = REPLACE(@Cmd, '@TableName', QUOTENAME(@TableName));
	PRINT @Cmd;
	EXEC (@Cmd);
	FETCH NEXT FROM cur INTO @TriggerName, @TableName;
END

CLOSE cur;
DEALLOCATE cur;

DROP TABLE DisabledTriggers;